<script setup lang="ts">
import { onMounted, provide, ref } from 'vue'

import { type Product } from '@/types/Product'
import { type ReceiptItem } from '@/types/ReceiptItem'

import ProductList from '@/components/ProductList.vue'
import MemberAndPromotionCard from './MemberAndPromotionCard.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import { useReceiptStore } from '@/stores/receipt'
import ReceiptCard from './ReceiptCard.vue'
import ReceiptDialog from './ReceiptDialog.vue'
import CancelDialog from './CancelDialog.vue'
import { usePromotionStore } from '@/stores/Promotion'
import { useProductStore } from '@/stores/Product'
import { usePosStore } from '@/stores/pos'
import { useMemberStore } from '@/stores/member'

const receiptStore = useReceiptStore()
const promotionStore = usePromotionStore()
const productStore = useProductStore()
const posStore = usePosStore()
const memberStore = useMemberStore()

const tab = ref(1)
const selected = (p: Product) => {
  console.log('ProductView ' + p)
  receiptStore.addReceiptItem(p)
  if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
}
const divReceiptItems = ref<HTMLElement | null>(null)
function showrecdialog() {
  receiptStore.showReceiptDialog()
}
function showdeldialog() {
  receiptStore.showDeleteDialog()
}

onMounted(async () => {
  promotionStore.getPromotions()
  posStore.getProducts()
  productStore.getProducts()
  await memberStore.getMembers()
})
</script>

<template>
  <v-container fluid>
    <v-row>
      <!-- Left Col -->
      <v-col cols="12" md="6" style="background-color: rgba(255, 255, 255, 0.5)">
        <v-sheet
          min-width="300"
          max-width="800"
          min-height="700"
          max-height="1000"
          elevation="6"
          color="rgba(253, 254, 254)"
        >
          <v-tabs v-model="tab" color="#f79c52" background-color="white" align-tabs="center">
            <v-tab :value="1" style="font-weight: bold; font-size: 17px">Drinks</v-tab>
            <v-tab :value="2" style="font-weight: bold; font-size: 17px">Foods</v-tab>
            <v-tab :value="3" style="font-weight: bold; font-size: 17px">Dessert</v-tab>
            <v-tab :value="4" style="font-weight: bold; font-size: 17px">Other</v-tab>
          </v-tabs>

          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList
                :products="posStore.products1"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList
                :products="posStore.products2"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList
                :products="posStore.products3"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="4">
              <ProductList
                :products="posStore.products4"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <!-- Right Col -->
      <v-col cols="12" md="6" style="background-color: rgba(255, 255, 255, 0.5)">
        <v-container style="padding: 0">
          <v-row dense :gutter="8">
            <!-- Show Order -->
            <v-col cols="12">
              <div ref="divReceiptItems" style="height: 300; overflow: auto">
                <v-sheet min-width="300" max-width="800" height="300" elevation="6">
                  <ReceiptDetailTable />
                </v-sheet>
              </div>
            </v-col>
            <!-- Show Member -->
            <v-col cols="12">
              <v-sheet
                min-width="300"
                max-width="800"
                max-height="300"
                elevation="3"
                color="rgba(114, 87, 42, 1)"
              >
                <MemberAndPromotionCard />
              </v-sheet>
            </v-col>
            <!-- Show Total Amount -->
            <v-col cols="12">
              <ReceiptCard />
            </v-col>
            <!-- Show Button -->
            <v-col cols="12">
              <v-sheet
                min-width="300"
                max-width="800"
                height="80"
                elevation="3"
                class="rounded-sheet"
                color="rgba(255, 255,255,0)"
              >
                <v-container>
                  <v-row style="font-family: 'Kanit', sans-serif">
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        rounded="x1"
                        height="50px"
                        style="
                          background-color: white;
                          font-size: x-large;
                          color: black;
                          font-weight: bold;
                        "
                        @click="showdeldialog"
                        >ยกเลิก</v-btn
                      >
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        rounded="x1"
                        height="50px"
                        style="
                          background-color: #f79c52;
                          font-size: x-large;
                          color: black;
                          font-weight: bold;
                        "
                        @click="showrecdialog"
                        >ชําระเงิน</v-btn
                      >
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <ReceiptDialog></ReceiptDialog>
  <CancelDialog></CancelDialog>
</template>

<style scoped></style>
